package tdd.tp02;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;




public class TestDB {
	private String host;
    private String user;
    private String base;
    private String pw;
	
	public TestDB(String host, String user, String base, String pw) throws ClassNotFoundException {
	
		Class.forName("org.postgresql.Driver");
		this.base = base;
		this.pw = pw;
		this.host = host;
		this.user = user;
	}
	
	private Connection connect() throws SQLException {
		return DriverManager.getConnection("jdbc:postgresql://" + host + ":5432/" + base, user, pw);	
	}
	
	private void init () throws SQLException {
		Connection cnx = connect();
		Statement stmt = cnx.createStatement();
		
		stmt.executeUpdate("DROP TABLE IF EXISTS T CASCADE");
		stmt.executeUpdate("CREATE TABLE T (ID INTEGER PRIMARY KEY, X INTEGER, Y INTEGER)");
		
		for (int i = 0 ; i < 1000; i++) {
			stmt.addBatch("INSERT INTO T VALUES (" + i + ", " + i + ", 0)");
		}		
		stmt.executeBatch();
		cnx.close();
	}
	
	
	private int complex (int i) {
		return 42;
	}
	
	public void concurrentUpdate () throws SQLException {
		
		Thread bgThread = new Thread () {
			
			@Override
			public void run () {
				try {
					System.out.println("Starting background thread");
					Connection cnx = TestDB.this.connect();
					Statement stmt = cnx.createStatement();
					
					stmt.executeUpdate("UPDATE T SET x = x + 1 WHERE MOD(x,2) = 0 AND y = 0");
					
					cnx.close();
				System.out.println("Finishing background thread");
			} catch (Exception e) { throw new RuntimeException(e); }
		}
				
		};
		Connection cnx = connect();
		Statement select = cnx.createStatement();
		Statement update = cnx.createStatement();
	    cnx.setAutoCommit(false); //Création de la transaction
		ResultSet res = select.executeQuery("SELECT * FROM T WHERE MOD(x,2) = 0");
		bgThread.start();
		
		while (res.next()) {
			
			update.executeUpdate("UPDATE T SET y = " + complex(res.getInt("y")) + " WHERE ID =" + res.getInt("id"));
		}
		cnx.commit(); //fin de transaction
		cnx.close();
		try {
			bgThread.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		
	}

	 public static void main(String [] args) {
		 try {

			 TestDB test = new TestDB("localhost", "kim","kim","kim");

			 test.init();
			 test.concurrentUpdate();
			 
		} catch (SQLException e) { e.printStackTrace();
		
		} catch (ClassNotFoundException e) {
		}
		 
	 }
		
}
	

